package com.zipcodewilmington.bankaccountlab;

import java.util.Scanner;

public class Atm {
    SavingsAccount sa = new SavingsAccount(100000);
    CheckingAccount ca = new CheckingAccount(4000);
    BusinessAccount ba = new BusinessAccount(500000);
    boolean running = false;


    public void start() {
        running = true;
        while (running == true) {

            System.out.println("Welcome to the Banky Wank!");
            System.out.println("Which account would you like to access?\n\n1. Checking\n2. Savings\n3. Business\n\n4. Exit");
            System.out.println("Please select 1, 2, 3, or 4");
            int accountChoice = intScanner();
            if (accountChoice == 1) {
                System.out.println("Balance: $" + ca.getBalance());
                actions(ca);
            } else if (accountChoice == 2) {
                System.out.println("Balance: $" + sa.getBalance());
                actions(sa);
            } else if (accountChoice == 3) {
                System.out.println("Balance: $" + ba.getBalance());
                actions(ba);
            } else if (accountChoice == 4) {
                running = false;
            } else {
                System.out.println("Please try again");
            }

        }
    }


    public void actions(Account p) {
        System.out.println("Would action would you like to take?\n1. Withdraw\n2. Deposit\n");
        System.out.println("Please select 1 or 2");
        int actionChoice = intScanner();
        if (actionChoice == 1) {
            selectWithdrawalAmount(p);
        } else if (actionChoice == 2) {
            selectDepositAmount(p);
        } else {
            System.out.println("Please try again");
        }

    }

    public void selectDepositAmount(Account p) {
        System.out.println("How much would you like to deposit?");
        int dp = intScanner();
        p.deposit(dp);
        System.out.println(dp + " deposited, your new balance is: " + p.getBalance());
    }

    public void selectWithdrawalAmount(Account p) {
        System.out.println("How much would you like to withdraw?");
        int wd = intScanner();
        if (wd < p.getBalance()) {
            p.withdrawal(wd);
            System.out.println(wd + " withdrawn, your new balance is: " + p.getBalance());
        } else {
            System.out.println("You don't have enough in your account, sorry!");
        }
    }

    public int intScanner() {
        Scanner sc = new Scanner(System.in);
        int input = 0;
        if (sc.hasNextInt()) {
            input = sc.nextInt();

        } else {
            System.out.println("Invalid input! Try Again!");
        }
        return input;
    }

}
