package com.zipcodewilmington.bankaccountlab;

import org.junit.jupiter.api.Test;

import static org.junit.jupiter.api.Assertions.*;

class AccountTest {

    @Test
    void withdrawal() {
        CheckingAccount ca = new CheckingAccount(10000);
        ca.withdrawal(500);
        double actual = ca.getBalance();
        double expected = 9500;
        assertEquals(expected, actual);

    }

    @Test
    void deposit() {
        CheckingAccount ca = new CheckingAccount(100000);
        ca.deposit(500);
        double actual = ca.getBalance();
        double expected = 100500;
        assertEquals(expected, actual);
    }
}